zoukankan      html  css  js  c++  java
  • HDU 1695 GCD(容斥定理)

    GCD

    Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 7529    Accepted Submission(s): 2773


    Problem Description
    Given 5 integers: a, b, c, d, k, you're to find x in a...b, y in c...d that GCD(x, y) = k. GCD(x, y) means the greatest common divisor of x and y. Since the number of choices may be very large, you're only required to output the total number of different number pairs.
    Please notice that, (x=5, y=7) and (x=7, y=5) are considered to be the same.

    Yoiu can assume that a = c = 1 in all test cases.
     

    Input
    The input consists of several test cases. The first line of the input is the number of the cases. There are no more than 3,000 cases.
    Each case contains five integers: a, b, c, d, k, 0 < a <= b <= 100,000, 0 < c <= d <= 100,000, 0 <= k <= 100,000, as described above.
     

    Output
    For each test case, print the number of choices. Use the format in the example.
     

    Sample Input
    2 1 3 1 5 1 1 11014 1 14409 9
     

    Sample Output
    Case 1: 9 Case 2: 736427
    Hint
    For the first sample input, all the 9 pairs of numbers are (1, 1), (1, 2), (1, 3), (1, 4), (1, 5), (2, 3), (2, 5), (3, 4), (3, 5).
     

    Source




        题意:输入五个整数a,b,c,d,k。要求从区间[a,b]取出一个x,从区间[c,d]取出一个y,使得GCD(x,y) == k求出有多少种情况,只是注意的是GCD(5,7)与GCD(7,5)是一种。


        思路:将x,y同一时候除以k。就转变成求x,y互质,就能用容斥定理做了。





    #include<iostream>
    #include<algorithm>
    #include<stdio.h>
    #include<string.h>
    #include<stdlib.h>
    #include<math.h>
    #include<vector>
    #include<queue>
    #include<stack>
    #include<map>
    
    #define N 101000
    
    using namespace std;
    
    vector<int>q[N];
    int num[N];
    int a,b,c,d,k;
    
    void init(){
        for(int i=0;i<=N;i++){
            q[i].clear();
        }
        for(int i=1;i<=100000;i++){
            int p = i;
            int pi = sqrt(p);
            for(int j=2;j<=pi;j++){
                if(p%j == 0){
                    q[i].push_back(j);
                    while(p%j == 0){
                        p = p/j;
                    }
                }
            }
            if(p!=1){
                q[i].push_back(p);
            }
        }
    }
    
    __int64 IEP(int ii,int pn){
        int pt = 0;
        __int64 s = 0;
        num[pt++] = -1;
        for(int i=0;i<q[ii].size();i++){
            int l = pt;
            for(int j=0;j<l;j++){
                num[pt++] = num[j]*q[ii][i]*(-1);
            }
        }
        for(int i=1;i<pt;i++){
            s += pn/num[i];
        }
        return s;
    }
    
    int main(){
        int T;
        init();
        int kk = 0;
        scanf("%d",&T);
        while(T--){
            scanf("%d%d%d%d%d",&a,&b,&c,&d,&k);
            if(b>d){
                int e = b;
                b = d;
                d = e;
            }
            if(k == 0){
                printf("Case %d: 0
    ",++kk);
                continue;
            }
            b = b/k;
            c = b+1;
            d = d/k;
            __int64 sum = 0;
            for(int i=1;i<=b;i++){
                sum += b - IEP(i,b);
            }
            sum = (sum+1)/2;
            for(int i=1;i<=b;i++){
                sum += d - c + 1 - IEP(i,d) + IEP(i,c-1);
            }
            printf("Case %d: %I64d
    ",++kk,sum);
        }
        return 0;
    }


     
  • 相关阅读:
    hdoj 6023 Automatic Judge
    hdoj 1170 Balloon Comes!
    初识vim操作和配置
    POJ 1611 The Suspects (并查集)
    HDU 1232 畅通工程 (并查集)
    计蒜客--两数之和
    计蒜客--爬楼梯 (动态规划)
    计蒜客--单独的数字 (位运算)
    计蒜客--最后一个单词的长度
    计蒜客-- 奇怪的国家 (位运算)
  • 原文地址:https://www.cnblogs.com/claireyuancy/p/7338350.html
Copyright © 2011-2022 走看看